<%option explicit%>
<!-- #include file="afhglobals.asp" -->
<%
'******************************************************************************
'  Copyright: HK Programming 
'  www.hkprog.com   Evaluation version
' Attachments and templates have been removed
'  Main Action Version 4.00
'  This program does multiple tasks.
'  1. Gets all forms fields
'  2. Uses configuration hidden files and configurationm file
'  4. Mails results to one or more people
'  5. Continues to another program or displays a message
'  6. Can use config_file or have values as hidden fields
'  7. March 20, 2008   Fix MYSql debug
' June 4, 2008  Free version with no database facilities
'********************************************************************************

'****************************************************************************
' Main program logic
' get all form fields and store in an array
' get all configuration options and store into an array
' do any validation to make sure all fields necessary for mailing are ok
' Do the actual mailing to site owner and or responder
' continue or write any messages
' Program is written in small subroutines that do specific tasks.
' It also uses subroutines in other program
' afhmailsubs.asp     has mailing subroutines
' afhtemplatesubs.asp has template parsing routines
' afhglobals.asp      has global variables
' afhlanguage_english.asp         has Language constan
' afhconfigsubs.asp    configuration values
' afhdisplaysubs.asp
' afhhtml.asp
'***************************************************************************
dim formname, conn, blnopened, blnattributes, newrecordno
dim rc
' Main logic starts here
errorcount=0
ConfigurationInit                  ' find out what person wants to do
Languageinit                       ' read language file
ActionvalidateConfigurationvalues  ' make sure minimum info is avaialble
if errorcount=0 then 
   ActionGetFormInputValues  formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount   ' put all form values into form arrays
   ActionvalidateForm                    ' validate this form fields
   if errorcount=0 then 
     ActionHandleMultiform   rc           ' see if it is multiple form
      if rc=0 then 
       ActionUpdatedatabase                 ' update database
       if errorcount=0 then 
         ActionMailform                       ' mail form if necessary
       end if  
      end if
      ActionContinue                       ' write html or continue if necessary
   end if
end if
if errorcount>0 then 
  ActionProcessFormErrors                      ' write errors if necessary
end if 

'**********************************************************************************
' we need to get minimum amount of information to determine
' where to mail to
' The referer is Ip address allowed to use form
'*******************************************************************************
Sub ActionvalidateConfigurationvalues
dim securityreferer
ActionValidateConfig  "config_emailaddress"
Actionvalidateconfig  "config_emailname"
ActionValidateconfig  "config_emailsubject"
ActionValidateconfig  "config_emailsystem"
Actionvalidateconfig  "config_emaildriver"
If errorcount=0 then
    securityreferer=readconfig("config_securityreferer")
    If securityreferer<>"" then
        ActionvalidateReferer  securityreferer
    end if
end if        
end sub
'********************************************************************************
' if there are a list of referers, make sure that this URL is correct
'*********************************************************************************
Sub ActionValidateReferer (referlist)
dim words(100), wordcount, i, ipaddress, length, prefix
dim referer
converttoarray referlist, words, wordcount,","
ipaddress=request.servervariables("HTTP_REFERER")
referer=convertReferer(ipaddress)
for i = 0 to wordcount-1
  length=len(words(i))
  prefix=left(referer, length)
  prefix=lcase(prefix)
  if prefix=lcase(words(i)) then
      exit sub
  end if
next
writeError  readlang("LangInvalidReferer")  & " " & referer
end sub
'*******************************************************************
' ihost will be http://abc.com/aaax/formname.htm
' strip off to get abc.com
'*******************************************************************
function ConvertReferer (ihost)
dim i, s, workhost, pos, prefix
workhost=lcase(ihost)
prefix=left(workhost,7)           ' see if http:// 
If prefix="http://" then 
    workhost=mid(workhost,8)
else
    If prefix="https://" then    ' see if https
      workhost=mid(workhost,9)
    end if  
end if
pos=instr(workhost,"/")           ' see if any folders
If pos>0 then
   workhost=mid(workhost, 1, pos-1) ' move anything before /
end if
ConvertReferer=workhost
end function

'****************************************************************************
' certain config values are required
' they count be in the form itself in in a configuration file
'****************************************************************************
Sub ActionValidateConfig (configname)
dim configvalue

configvalue=readconfig(configname)
if configvalue="" then
       writeError configname & " " & " " & readlang("langrequired")
end if      
end sub

'********************************************************************************
' If there are requited fields (config_fieldrequired) then make sure there is a value
' for that field.
' get any val_xxxxx   where xxx is the field name
' if found then use that to validate the field
' types are numeric, alphanumeric, creditcard, expirydate
' alpha, 
'********************************************************************************
Sub ActionValidateForm
dim i, valtype, msg, temp, lenprefix, rc, tempvalue
dim requiredfields(200), requiredcount, fieldname, fieldvalue,j, fieldcaption
dim config_fieldrequired
dim afhform
If lcase(readconfig("config_captcha"))="yes" then 
   Validatecaptcha
end if   
afhform=readconfig("config_afhform")
if afhform<>"" then
    ValidateforminDatabase afhform 
  ' created by afh form generator
    exit sub
end if  
formname=readconfig("config_formname")
if formname="" then
   formname="unknown"
end if   
requiredcount=0
config_fieldrequired=readconfig("config_fieldrequired")
If config_fieldrequired<>"" then 
    converttoarray config_fieldrequired, requiredfields, requiredcount,","
end if
If requiredcount>0 then                    ' see if required
        Validaterequiredfields  requiredfields, requiredcount, rc
end if  
If rc=0 then 
 for i=0 to formfieldcount-1
      fieldname=formfieldnames(i)                ' form field name
      fieldvalue=formfieldvalues(i)              ' its value
      fieldcaption=readcaption(fieldname, formname)  ' caption may be in language fil
        temp=validationprefix & fieldname
        valtype=readconfig(temp)                 ' any validation rule
        if valtype<>"" then                      ' yes
           If fieldvalue<>"" then 
             valididate fieldname,fieldvalue,fieldcaption,valtype,msg, rc  ' valid value
             if msg<>"" then                       ' any message is an error
               writeError  msg 
             end if 
            else
                  writeError  fieldname & " " & readlang("langrequired")
            end if        
        end if
 
 next
end if
If rc=0 then
   Validatematchfields rc
end if   
end sub

'************************************************************************
' see if any fields are required.
' search required array
' if found make sure there is a value
'************************************************************************
sub Validaterequiredfields (requiredfields, requiredcount, rc) 
dim i, requiredfield, lfieldname, tempvalue, formindex, formrc, fieldcaption
rc=0
lfieldname=lcase(fieldname)
for i = 0 to requiredcount-1
   requiredfield=lcase(requiredfields(i))
   locaterequiredfield requiredfield, tempvalue, formrc
   if formrc=0 then 
      if tempvalue=""  then
           fieldcaption=readcaption(requiredfield, formname)
           writeError  fieldcaption & " " & readlang("langrequired")
           rc=4
      end if    
   else
        fieldcaption=readcaption(requiredfield, formname)
        writeError  fieldcaption & " " & readlang("langrequired")
        rc=4
   end if           
next
end sub
'************************************************************************
' some type of error has occurred. All the errors are in errormsg field
' we need to determine if there is some type of special header to put out
'*****************************************************************************  
Sub ActionProcessFormErrors
ActionDisplaypageHeader                      ' put out special header for form
ActionDisplayerrors                          ' write messages
response.write "<a href='JAVASCRIPT:history.go(-1);'>" & readlang("langbackup") & "</a><br>"
ActionDisplaypageTrailer                     ' put out special trailer for form  
end sub

'*****************************************************************************************
' if there is a mailing template, then use it
' we generate a template and then do subsitition within that template
' if there is no mailing template, create  agenerate template based on form fields
' 
'*********************************************************************************
Sub Actionmailform
ActionMailtoMerchant                    ' first mail to merchant
Actionmailtocustomer                    ' mailto customer
end sub

Sub ActionMailToMerchant
dim body, htmlformat, i, filename, rc
filename=readconfig("config_emailtemplate")    ' is user supplying own template
filename=ValidateTemplateName(filename)                  ' only allows .htm and .txt
rc=0
if filename="" then
  htmlformat="txt"
  TemplateGenerateTemplate formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount, tarray, tarraycount
  AddSpecialfields                     ' add server and other special field
  TemplateSubstitute  tarray, tarraycount, formfieldnames, formfieldvalues, tempdbtypes, formfieldcount   
else
  Readsystemfile  filename, rc, tarray, tarraycount
  DeletermineMailFormat filename, htmlformat
  If htmlformat<>"HTML" then 
     AddSpecialfields                     ' add server and other special field
  end if   
  TemplateSubstitute  tarray, tarraycount, formfieldnames, formfieldvalues, tempdbtypes, formfieldcount 
end if
if rc=0 then       
 ActionSetupmailbody tarray, tarraycount, body, htmlformat
 ActionPerformmailingMerchant  body, htmlformat
end if 
end sub

'***********************************************************************************
' mail to site owner. There may be multiple email addresses
' if config_emailaddress= a@b.com,c@d.com then email is sent to to addreses
'
'***********************************************************************************
Sub ActionPerformmailingMerchant  (body, htmlformat)
dim responderemailfield, responderemailaddress, responderyesno
dim mailfromresponder
dim addresses(10), addresscount, i
'to avoid anti spamming issues the email address always will be the merchant
'
mailfromname=readconfig("config_emailname")' person to email
mailfromaddress=readconfig("config_emailaddress")' email address
convertToArray mailfromaddress, addresses, addresscount,","
responderemailfield=readconfig("config_emailresponderfield")
if responderemailfield<>"" then
   responderemailaddress=request(responderemailfield)
end if
If lcase(readconfig("config_emailfromresponder"))="yes"  then 
   mailfromresponder=true
else
   mailfromresponder=false
end if      
If mailfromresponder=true and responderemailaddress<>"" then 
    mailfromaddress= responderemailaddress
    mailfromname= responderemailaddress
end if     
mailtoname=readconfig("config_emailname")              ' name again
mailsubject=readconfig("config_emailsubject")               ' subject
mailhtmlformat=htmlformat                ' text or html
mailattachmentlist=""                       ' no attachment
mailerror=""                             ' reset any aerror
mailsystem=readconfig("config_emailsystem")            ' email system
maildriver=readconfig("config_emaildriver")                'email interface (aspmail cdonts)
for i = 0 to addresscount-1
   mailtoaddress=addresses(i)
   mailfromaddress=addresses(i)
   if mailfromresponder=true and responderemailaddress<>"" then
     mailfromaddress=responderemailaddress
   end if   
 ' this goes to site owner
  WritemailMessage mailfromname, mailfromaddress, mailtoname, mailtoaddress, mailsubject, body, maildriver, mailsystem, mailhtmlformat, mailattachmentlist, mailerror
next  
end sub

'**************************************************************************
' mail to customer only if they merchnat says to and there is an email address
'***************************************************************************
Sub ActionMailToCustomer
dim body, htmlformat, i, filename, rc
dim responderemailfield, responderemailaddress, responderyesno
dim addresses(10), addresscount
responderemailaddress=""
responderyesno=readconfig("config_emailresponder")  ' no merchnat to customer
If lcase(responderyesno)<>"yes" then exit sub       ' no mailing to customer
responderemailfield=readconfig("config_emailresponderfield")
if responderemailfield<>"" then
   responderemailaddress=request(responderemailfield)
end if   
if  responderemailaddress="" then exit sub          ' no email addresss  
filename=readconfig("config_emailrespondertemplate")  ' is user supplying own template
filename=ValidateTemplateName(filename)
rc=0
if filename="" then 
  htmlformat="txt"
  TemplateGenerateTemplate formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount, tarray, tarraycount
  AddSpecialfields                     ' add server and other special field
  TemplateSubstitute  tarray, tarraycount, formfieldnames, formfieldvalues, tempdbtypes, formfieldcount   
else
  Readsystemfile  filename, rc, tarray, tarraycount
  DeletermineMailFormat filename, htmlformat
  If htmlformat<>"HTML" then 
 '    AddSpecialfields                     ' add server and other special field
  end if   
  TemplateSubstitute  tarray, tarraycount, formfieldnames, formfieldvalues, tempdbtypes, formfieldcount 
end if
if rc=0 then       
 ActionSetupmailbody tarray, tarraycount, body, htmlformat
 ActionPerformmailingCustomer  body, htmlformat, responderemailaddress, responderemailaddress
end if 
end sub

'************************************************************************
' send email to customer with attachments if any
'************************************************************************
Sub ActionPerformmailingCustomer  (body, htmlformat, toaddress, toname)
dim addresses(10), addresscount, i
mailfromaddress=readconfig("config_emailaddress")' email address
convertToArray mailfromaddress, addresses, addresscount,","
mailfromaddress= addresses(0)
mailfromname=readconfig("config_emailname")' person to email
mailtoname=toname
mailtoaddress=toaddress
mailsubject=readconfig("config_emailsubject")               ' subject
mailhtmlformat=htmlformat                ' text or html
mailerror=""                             ' reset any aerror
mailattachmentlist=""
mailsystem=readconfig("config_emailsystem")            ' email system
maildriver=readconfig("config_emaildriver")                'email interface (aspmail cdonts)
WritemailMessage mailfromname, mailfromaddress, mailtoname, mailtoaddress, mailsubject, body, maildriver, mailsystem, mailhtmlformat, mailattachmentlist, mailerror
end sub


'******************************************************************************
' convert array to a styring separate by crlf
'******************************************************************************
Sub ActionSetupmailbody (tarray, tarraycount, body, htmlformat)
dim delimiter, i
body=""
If lcase(htmlformat)="html" then
   delimiter=""
else
  delimiter= chr(13) & chr(10)
end if  
for i = 0 to tarraycount-1
  body=body & tarray(i) & delimiter
next  
body=body & delimiter & readlang("langevalmessage")
end sub

'********************************************************************************
' Gets all fields in form and stores them into an array
'******************************************************************************
Sub ActionGetFormInputValues( formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount)
dim field, fieldvalue, fieldnames, i
formfieldcount=0
ActionGetFieldOrder  formfieldnames,formfieldcount
for i=0 to formfieldcount-1
    fieldvalue=request.form(formfieldnames(i))
    formfieldvalues(i)=fieldvalue
   ' debugwrite formfieldnames(i) & "=" & fieldvalue
    formfieldsvalid(formfieldcount)=True
    If fieldvalue<>"" then
       formfieldlengths(formfieldcount)=len(fieldvalue)
    end if   
next    
ActionGetSessInputValues formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount
ActionAddPrivateFields  formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount
end sub
'****************************************************************************
' read and parse config file in form
'  abc="bc"

Sub ActionGetFieldOrder  (fieldnames,formfieldcount)
'**********************************************************************************
' determine order of form fields
' config_fieldorder
' config entry is empty, then use way form is defined
' ignore config_ and val_
' *********************************************************************************
dim count, fieldlist, field, j, fieldprefix, i, rc
dim excludefields, excludefieldlist, excludefieldcount
fieldlist=readconfig("config_fieldorder")   ' see if user defined list
if fieldlist<>"" then 
   converttoarray fieldlist, fieldnames, formfieldcount,","
   exit sub
end if
' see if any specific excluded
excludefieldlist=readconfig("config_fieldexclude")
excludefieldcount=0
if excludefieldlist<>"" then 
    excludefields=split(excludefieldlist,",")
    excludefieldcount=ubound(excludefields)+1
    for i = 0 to excludefieldcount-1
       excludefields(i)=lcase(excludefields(i))
    next
end if       
for each field in Request.Form
        CheckexcludeConfiguration field, rc   ' see if it really a configuration
        If rc=0 then                          ' no, see if it is excluded 
          If excludefieldcount>0 then
              Checkexcludedfields field, excludefields, excludefieldcount, rc
          end if
          if rc=0 then     
            fieldnames(j)=field
            j=j+1
           end if
        end if   
next
formfieldcount=j 
'debugwrite "formfieldcount=" & j
end sub
'************************************************************************
' exclude as standard form field any 
'config_ and val_ form fields
'************************************************************************
Sub CheckExcludeConfiguration (fieldname, rc)
rc=0
dim fieldprefix
fieldprefix=lcase(left(fieldname, 7))
if fieldprefix="config_"  then
    rc=4                            ' exclude this config_
    exit sub
end if    
fieldprefix=lcase(left(fieldname, len(validationprefix)))       ' val_    
if fieldprefix=validationprefix  then 
     rc=4           '  exclude val_
     exit sub
end if
end sub
'********************************************************************************
' see if field should be excluded
'*******************************************************************************
sub  Checkexcludedfields (field, excludefields, excludefieldcount, rc)
dim i, lfield
rc=0
lfield=lcase(field)
for i=0 to  excludefieldcount-1
   if lfield=excludefields(i) then
       rc=4
       exit sub
   end if
next       
end sub
'
Sub DebugWrite (msg)
response.write msg & "<br>"
end sub


'*****************************************************************************
' take a string in form
'  a,b,c and turn into an array
'*****************************************************************************
Sub ConvertToArray (record,words,wordcount,delimiter)
Dim pos 
Dim recordl
Dim bytex
Dim temprec
Dim maxwords
Dim i
maxwords = 10
temprec = record
Dim maxentries
pos = 1
wordcount = 0
' make sure word array is null
maxentries = UBound(words)
For i = 0 To maxentries - 1
   words(i) = ""
Next
recordl = Len(temprec)
' first eliminate leading blanks
Do
   bytex = Mid(temprec, pos, 1)
   While bytex = " " And pos <= recordl
     pos = pos + 1
     bytex = Mid(temprec, pos, 1)
   
   Wend
' copy word into word array
   While bytex <> delimiter And pos <= recordl
     words(wordcount) = words(wordcount) & bytex
     pos = pos + 1
     bytex = Mid(temprec, pos, 1)
     
   Wend
   wordcount = wordcount + 1
   pos = pos + 1
   If wordcount > maxentries Then Exit Sub
Loop Until pos > recordl
End Sub


'*****************************************************************************
' adds  message  to errormsg global variable
'****************************************************************************
Sub writeError (msg)
errormessages(errorcount)=msg
errorcount=errorcount+1
end sub
'***********************************************************************
Sub ActionDisplayErrors 
dim i, msg
if errorcount=0 then exit sub
Response.write "<table align=center border='1'>"
for i =0 to errorcount-1
  msg=errormessages(i) 
  response.write "<tr><td class='NormalError'>" & msg & "</td></tr>"
next  
response.write "</table>"
end sub

'******************************************************************
' General Usage Display Headers and trailers on ASP pages
'***************************************************************
Sub ActionDisplayPageHeader
displayPageheader
end sub
Sub ActionDisplayPageTrailer
displayPagetrailer
end sub
'*********************************************************************************
' at this point we have finished the mailing.
' We either write message to responder, generate a hyperlink or redirect
' Depending on configuration
' completionformat writes results using a template
'*********************************************************************************
Sub ActionContinue
dim url, caption, filename, rc
dim config_completionurl, config_completionlink, config_completiontext
dim config_completionformat, config_completionformattemplate
config_completionurl=readconfig("config_completionurl")
config_completionlink=readconfig("config_completionlink")
config_completiontext=readconfig("config_completiontext")
config_completionformat=readconfig("config_completionformat")
config_completionformattemplate=readconfig("config_completionformattemplate")
config_completionformattemplate=ValidateTemplatename(config_completionformattemplate)
if errorcount>0 then 
	  ActionDisplayerrors
	  errorcount=0
end if	  
if config_completionurl<>"" then
   response.redirect config_completionurl
end if
' we are staying on same site.
' so put out a header and message
ActionDisplayPageheader                      ' put out header HTML
If  config_completiontext<>"" then
   response.write "<br>"
   response.write   config_completiontext & "<br>"
end if
If lcase(config_completionformat)="yes" then 
    actionCompletionFormat                    ' display each form field
else
    if config_completionformattemplate<>"" then
         actionCompletionFormatTemplate config_completionformattemplate  ' display wqith template
    end if
end if         
'debugwrite "completionlink=" & config_completionlink
if config_completionlink<>"" then
   caption="Continue"
   filename=config_completionlink
   url="<a href='" & filename & "'>" & caption & "</a>" 
   response.write "<br>" & url & "<br>"
end if

ActionDisplayPageTrailer                   ' put out header HTML         
end sub
'*****************************************************************************
' See if database update is required
' get all field names in table
' For each form field
'    see if database field exists
'    if yes, add field to update list
'    if no add to list of fields to add to database
'next
'   If there are fields to add to database add then to results table
'   insert the record into the database
'***************************************************************************          
sub ActionUpdatedatabase
' not in free version

end sub  
'*************************************************************************
' if there are form fields that are not in the current record
' then add them
' at this point we have all the form field values in
' formfieldnames, formfieldvalues, formfieldcount
' We have all database fields in
' dbfieldnames, dbfieldtypes, dbfieldcount
'****************************************************************************

'*************************************************************************
sub Actionadddatabasefields (conn, dbtable)
end sub
'*****************************************************************************
' insert into database the record and then record back the record no
' The field values are already stored in formfields and formvalues array
'***************************************************************************
Sub ActionAddFormToDatabase (conn, dbtable, recordno)
end sub

'*****************************************************************************
' insert into database the record and then record back the record no
' The field values are already stored in formfields and formvalues array
'***************************************************************************
Sub ActionAddFormToDatabaseMYSQL (conn, dbtable, recordno)
end sub


'**********************************************************************
' special fields are in specialfields list
'**********************************************************************
Sub HandleSpecialFields (fieldname, fieldvalue, rc, dbtable)
rc=4
select case fieldname
   case "resultipaddress"
      fieldvalue=request.servervariables("REMOTE_ADDR")
      rc=0
   case "resultdate"
      fieldvalue=getCurrentdate()
      rc=0
   case "resulttime"
      fieldvalue=getCurrenttime()
      rc=0 
   case "resultform"
      fieldvalue=formname
      rc=0  
   case "resulttable"   
      fieldvalue=dbtable
      rc=0 
end select      
end sub

sub ActionFindFormRecordField (fieldname, fieldvalue)
dim i, lfieldname
lfieldname=lcase(fieldname)
fieldvalue=""
for i = 0 to formfieldcount-1
   if lfieldname=lcase(formfieldnames(i)) then
     fieldvalue=formfieldvalues(i)
     exit sub
   end if  
next   
end sub
'**********************************************************************

sub ActionLogResponse (conn, dbtable, recordno)
dim sql, fieldvalue, fieldtype, logtable 
dim addnames, addvalues
addnames=""
addvalues=""
Logtable="afhformlog"
fieldtype="Text"
' ipaddres of responder
fieldvalue=request.servervariables("REMOTE_ADDR")
createinsertstring addnames,addvalues,"resultipaddress",fieldvalue, fieldtype
'
fieldvalue=getcurrentdate()
createinsertstring addnames,addvalues,"resultdate",fieldvalue, "Date"
'
fieldvalue=getcurrentTime()
createinsertstring addnames,addvalues,"resulttime",fieldvalue, "Time"
'
fieldvalue=formname
createinsertstring addnames,addvalues,"resultform",fieldvalue, fieldtype
'
fieldvalue=dbtable
createinsertstring addnames,addvalues,"resulttable",fieldvalue, fieldtype
'
fieldvalue=recordno
createinsertstring addnames,addvalues,"resultrecordno",fieldvalue, "Int"

sql="Insert into "& logtable & "(" & addnames & ") values(" & addvalues & ")"
conn.execute(sql)
end sub
'************************************************************************
' templates with .htm are htmlall others are text
'************************************************************************
sub DeletermineMailFormat (filename, htmlformat)
dim suffix
suffix=right(filename,3)
if lcase(suffix)="htm" then
   htmlformat="HTML"
else
   htmlformat="TXT"
end if      
end sub

'*************************************************************************
' add special fields to template. These can be server variables
' config_servervars   server variables
' config_specialvars  special variables such as Date, Time
'*************************************************************************
Sub AddSpecialFields
dim specialfieldlist, specialfields(50), specialfieldcount
dim i, record
specialfieldlist=readconfig("config_servervars")
if specialfieldlist<>"" then 
  converttoarray specialfieldlist, specialfields, specialfieldcount,","
  for i =0 to specialfieldcount-1
   record=specialfields(i) & ": "  & templeftdelimiter  & "SERVERVARS " & specialFields(i)  & temprightdelimiter 
   tarray(tarraycount)=record
   tarraycount=tarraycount+1
  next   
end if 
specialfieldlist=readconfig("config_specialvars")
if specialfieldlist<>"" then 
  converttoarray specialfieldlist, specialfields, specialfieldcount,","
  for i =0 to specialfieldcount-1
   record=specialfields(i) & ": " &  templeftdelimiter  & " SPECIAL "  & specialFields(i)  & temprightdelimiter 
   tarray(tarraycount)=record
   tarraycount=tarraycount+1
  next   
end if  
end sub

Sub Normalizefieldvalue (fieldname, fieldvalie, fieldtype)
dim uvalue
if fieldtype="YesNo" then
   if fieldvalue="0" or fieldvalue = "1" then exit sub
   uvalue=ucase(fieldvalue)
   if uvalue="TRUE" or uvalue="YES" then
       fieldvalue=1
       exit sub
   end if
   If uvalue="FALSE" then
     fieldvalue=0
     exit sub
   end if
   fieldvalue=0
   exit sub
end if          
end sub
'***************************************************************************
' Confirmation display 
'***************************************************************************
sub ActionCompletionFormattemplate(ifilename)
dim filename, rc, formfieldtypes(255),i
filename=ifilename
Readsystemfile  filename, rc, tarray, tarraycount
If tarraycount=0 then
     debugwrite "Unable to find " & filename
end if
TemplateSubstitute  tarray, tarraycount, formfieldnames, formfieldvalues, formfieldtypes, formfieldcount 
for i = 0 to tarraycount-1
   response.write tarray(i) & vbcrlf
next   
end sub
'************************************************************************************
' display each form field
'***********************************************************************************
sub ActionCompletionFormat
dim i
responsewrite htmltable
for i = 0 to formfieldcount-1
   fieldname=formfieldnames(i)
   fieldvalue=formfieldvalues(i)
   fieldname=readcaption(fieldname, formname)   ' july 16
   FormatDetailRow fieldname, fieldvalue
  
next   
responsewrite htmltableend
end sub 

Sub FormatdetailRow (fieldname, fieldvalue)
Responsewrite "<tr>" & htmlleftcolumn & fieldname & "</td>"
Responsewrite htmlrightcolumn  & fieldvalue & "</td>"
responsewrite "</tr>"
end sub


'**************************************************************************
' for multipart forms we save the results in a cookie
' set rc=4
' otherwise set rc=0
'*************************************************************************
Sub ActionHandleMultiform (rc)
dim config_multiform, cookiefieldname, cookievaluename
dim i
dim cookiefields(1000), cookievalues(1000), Tempcount
rc=0
config_multiform=readconfig("config_multiform")
'not a multipart form
if config_multiform="" then exit sub
formname=readconfig("config_formname")
if formname="" then
   formname="unknown"
end if
cookiefieldname=formname & "_" & "fields"
cookievaluename=formname & "_" & "values"
' get previous pages
readcookiearray cookiefieldname, cookiefields, tempcount
readcookiearray cookievaluename, cookievalues, tempcount
'debugwrite "cookiecount=" & tempcount & " formcount=" & formfieldcount
' add new form fields
for i = 0 to formfieldcount-1
  cookiefields(tempcount)=formfieldnames(i)
  cookievalues(tempcount)=formfieldvalues(i)
  tempcount=tempcount+1
next
If lcase(config_multiform)="end"  then
   for i = 0 to tempcount-1
      formfieldnames(i)=cookiefields(i)
      formfieldvalues(i)=cookievalues(i)
  next
  formfieldcount=tempcount  
  rc=0
   exit sub
end if    
writecookiearray cookiefieldname, cookiefields, tempcount
writecookiearray cookievaluename, cookievalues, tempcount
Displaycookies  
rc=4
end sub
'*************************************************************************************
' form fields are stored in the database table afhform fields
' they could be required. Drop down lists could have tgheir prompt value
' this is replace by null if thedy match
'**********************************************************************************
sub ValidateFormInDatabase (formname)
dim fsql, frs, fconn, required, fieldcaption, valtype, msg, rc,i
opendatabase fconn
' used to handle split fields such as generated dates
Action_processSplitfields fconn, formname, formfieldnames, formfieldvalues, formfieldcount
for i=0 to formfieldcount-1
      fieldname=formfieldnames(i)                ' form field name
      fsql="select * from afhformfields where fieldformname='" & formname & "'"
      fsql=fsql & " and fieldname='" & fieldname & "'"
      set frs=fconn.execute(fsql)
      If not frs.eof then
          ActionCorrectFormValue frs, formfieldnames(i), formfieldvalues(i)
          fieldvalue=formfieldvalues(i)              ' its value
          fieldcaption=getrsfield(frs, "fieldcaption")
          required=getrsfield(frs,"fieldrequired")
          if lcase(required)="yes" then
              if fieldvalue="" then
                 writeError  fieldcaption & " " & readlang("langrequired")
              end if
          end if
          valtype=getrsfield(frs,"fieldvalidation")
          If valtype<>"" then
             if fieldvalue<>"" then
                 msg=""
                 valididate fieldname,fieldvalue,fieldcaption, valtype,msg, rc  ' valid value
                 if msg<>""  then
                       writeError  msg 
                 end if
              end if
          end if
        end if  
        closerecordset frs
next
validaterequiredboxes fconn, formname             ' validate required checkboxes and radios
closedatabase fconn
end sub
'************************************************************************************
'dropdown and multiple values may have a prompt such as Select
' if fieldvalue= prompt, replace it with nothing
'***********************************************************************************
Sub ActionCorrectFormValue (frs, formfieldname, formfieldvalue)
dim fieldtype, fieldprompt
if formfieldvalue="" then exit sub
fieldtype=getrsfield(frs,"fieldtype")
fieldprompt=getrsfield(frs,"fieldprompt")
fieldtype=lcase(fieldtype)
if fieldtype="dropdown" or fieldtype="multiple" then
    if fieldprompt=formfieldvalue then
        formfieldvalue=""
    end if
end if        
end sub

'******************************************************************************
' this logic is used to handle split fields such as generated dates
' it combines fields into a complete value and adjusts the formfields and values
' to eliminate the separate parts as items
'****************************************************************************
sub Action_ProcessSplitfields (fconn, formname, formfieldnames, formfieldvalues, formfieldcount)
dim fsql, rs, fieldname, tempname, tempvalue, dd,mm,yy, formindex, rc
dim datetype, resetfields, newdate, dateformat, dateparts(5), datecount, i
dim valuecount
dim firstchar
datetype="datefields"
resetfields=false
fsql="select * from afhformfields where fieldformname='" & formname & "'"
fsql = fsql &  " and fieldtype='" & datetype & "'"
set rs=fconn.execute(fsql)
if rs.eof then
   closerecordset rs
   exit sub
end if
do while not rs.eof
   Fieldname=getrsfield(rs,"fieldname")
   dateformat=getrsfield(rs,"fieldvalidationlist")
   if dateformat="" then dateformat="d m yy"
   convertToarray dateformat, dateparts, datecount, " "
   valuecount=0
   newdate=""
   for i = 0 to datecount-1
    tempname=fieldname & "_" & dateparts(i)
    tempvalue=""
    firstchar=lcase(left(dateparts(i),1)) 
    locateformfield tempname, tempvalue, formfieldvalues, formfieldnames, formfieldcount, formindex, rc
    if rc=0 then   
        action_combinedate newdate, tempvalue, valuecount
        formfieldnames(formindex)=""
        resetfields=true
    end if 
  next  
   'debugwrite "valuecount=" & valuecount & " newdate=" & newdate
   If datecount<>valuecount then 
        newdate=""      
   end if  
   formfieldnames(formfieldcount)=fieldname    ' add a new field to form fields
   formfieldvalues(formfieldcount)=newdate
   formfieldcount=formfieldcount+1
  rs.movenext  
loop
closerecordset rs   
If Resetfields=true then
   action_cleanupformfields formfieldnames, formfieldvalues, formfieldcount
end if   
end sub
'*************************************************************************
' the partial names have been set to empty
' we need to cleanup the arrays by eliminating empty field names
'*************************************************************************
sub   action_cleanupformfields (formfieldnames, formfieldvalues, formfieldcount)
dim tformfieldcount, tformfieldnames(255), tformfieldvalues(255)
dim i
tformfieldcount=0
for i = 0 to formfieldcount-1
  if formfieldnames(i)<>"" then
     tformfieldnames(tformfieldcount)=formfieldnames(i)
     tformfieldvalues(tformfieldcount)=formfieldvalues(i)
     tformfieldcount=tformfieldcount+1
  end if
next
formfieldcount=0
for i = 0 to tformfieldcount-1
     formfieldnames(formfieldcount)=tformfieldnames(i)
     formfieldvalues(formfieldcount)=tformfieldvalues(i)
     formfieldcount=formfieldcount+1
next     
end sub

Sub action_combinedate (newdate, tempvalue, valuecount)
if tempvalue="" then exit sub
valuecount=valuecount+1     ' count number that have values
if newdate<>"" then
        newdate=newdate & "/"
end if
newdate=newdate & tempvalue
end sub
'*********************************************************************
' search fields in lower case
'*********************************************************************
sub  locaterequiredfield (fieldname, fieldvalue, rc)
dim i, formindex
for i = 0 to formfieldcount-1
    if fieldname=lcase(formfieldnames(i)) then
       formindex=i
       fieldvalue=formfieldvalues(i)
       rc=0
       exit sub
    end if
next
rc=4
formindex=-1        
end sub
'*******************************************************************************
' radio and checkbox mau not have a form field
' so need to validate them separately
'******************************************************************************
sub validaterequiredboxes (fconn, formname)
dim fsql, frs, fieldname, fieldvalue, fieldcaption
fsql="select * from afhformfields where fieldformname='" & formname & "'"
fsql = fsql &  " and (fieldtype='checkbox' or fieldtype='radio') and fieldrequired='yes'"
set frs=fconn.execute(fsql)
do while not frs.eof
   fieldname=frs("fieldname")         ' get field name
   locaterequiredfield fieldname, fieldvalue, rc
   if rc=4 then 
      fieldcaption=getrsfield(frs, "fieldcaption")
      writeError  fieldcaption & " " & readlang("langrequired")
   end if     
   frs.movenext    
loop
closerecordset frs
end sub
'***************************************************************
' see if any two fields match
' aaa,bbb;ddd;eef
'*****************************************************************
sub validatematchFields (rc)
dim config_matchfields
rc=0
dim matchfields(100), matchcount, fieldstomatch(10), fieldstomatchcount
dim field1, field2, value1,value2, caption1, caption2, i
matchcount=0
config_matchfields=readconfig("config_matchfields")
If config_matchfields="" then exit sub
converttoarray config_matchfields, matchfields, matchcount,","
for i = 0 to matchcount-1
   converttoarray matchfields(i), fieldstomatch, fieldstomatchcount,";"
   If fieldstomatchcount=2 then
      field1=fieldstomatch(0)
      field2=fieldstomatch(1)
      value1=request.form(field1)
      value2=request.form(field2)
      If lcase(value1)<>lcase(value2) then
          caption1=readcaption(field1,formname)
          caption2=readcaption(field2,formname)
          writeerror caption1 & " does not match " & caption2
          rc=4
      end if  
   end if   
next        
end sub
'*********************************************************************************
' add private session variables
' config_privatesession="aaa,bbb"
'********************************************************************************
sub ActionGetSessInputValues (formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount)
dim specialfieldlist, specialfields(50), specialfieldcount
dim i, record
specialfieldlist=readconfig("config_privatesession")
if specialfieldlist<>"" then 
  converttoarray specialfieldlist, specialfields, specialfieldcount,","
  for i =0 to specialfieldcount-1
   formfieldnames(formfieldcount)=specialfields(i)
   formfieldvalues(formfieldcount)=session(specialfields(i))
'   debugwrite "saving " & specialfields(i) & "value=" & formfieldvalues(formfieldcount)
   formfieldcount=formfieldcount+1
  next
end if 
end sub
'********************************************************************************
' do private fields
'********************************************************************************
sub ActionAddPrivateFields  (formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount)
dim specialfieldlist, specialfields(50), specialfieldcount
dim i, rc
specialfieldlist=readconfig("config_privatefields")
if specialfieldlist<>"" then 
  converttoarray specialfieldlist, specialfields, specialfieldcount,","
  for i =0 to specialfieldcount-1
   ProcessPrivatefield specialfields(i), fieldvalue, rc
   if rc=0 then 
     formfieldnames(formfieldcount)=specialfields(i)
     formfieldvalues(formfieldcount)=fieldvalue
     formfieldcount=formfieldcount+1
   end if  
  next
end if 

end sub
%>
